/*
 *    functions for the graphic output of the pixmap
 */


#include "ct1.h"
GdkFont *font, *smallfont, *symbfont, *ssymbfont,*slfont;

#ifndef MIN
#define MIN(a, b)        ((a) < (b) ? (a) : (b))
#endif
#ifndef MAX
#define MAX(a, b)        ((a) > (b) ? (a) : (b))
#endif

void 
CreatePix (GtkWidget * widget, GdkPixmap * picture)
/* initializes fonts, linestyles and factors */
{
/*
  float ztab[] =
  {0.6, 0.8, 1};
  int ltab[] =
  {0, 2, 2};
  int ftab[] =
  {3, 5, 6};
*/
  float ztab[] =
  {0.4,0.6, 0.8, 1,1.2};
  int ltab[] =
  {0,0, 2, 2, 2};
  int ftab[] =
  {2, 3, 4, 5, 6};

/*fprintf(stderr,"zoom factor %d, using font %d\n",zoom_factor,ftab[zoom_factor] );         
*/
  size_factor = ztab[zoom_factor];
  head.pix_width =1600; 
  head.pix_height = 1600;
  Set_Line (widget, ltab[zoom_factor]);

  if (!Load_Font (ftab[zoom_factor]))
    {
      fprintf (stderr, "chemtool: can't load any font\n");
      exit (1);
    }

/*       fprintf(stderr,"re-init pixmap %d x %d\n",
   widget->allocation.width,widget->allocation.height); */
/*
   picture = gdk_pixmap_new((GdkWindow*) widget->window,
   widget->allocation.width,widget->allocation.height
   , -1);
 */
/*      CopyPlane(widget,picture); */

}

void 
FreePix (GtkWidget * widget, GdkPixmap * picture)
/* erases the drawing area */
{
  GdkRectangle update_rect;
    gdk_draw_rectangle (picture,
			widget->style->white_gc,
			TRUE, 0, 0,
			widget->allocation.width, widget->allocation.height);

  update_rect.x = 0;
  update_rect.y = 0;
  update_rect.width = widget->allocation.width;
  update_rect.height = widget->allocation.height;
  gtk_widget_draw ((GtkWidget *) widget, &update_rect);

/*
   if (picture)
   gdk_pixmap_unref(picture);
 */
/*      picture=(void *) NULL; */
}



void 
CopyPlane (GtkWidget * widget, GdkPixmap * picture)
/* updates the display with the contents of the background pixmap */
{
/****
    XCopyPlane(XtDisplay(pix), picture, XtWindow(pix), 
    DefaultGCOfScreen(XtScreen(pix)), 
    0, 0, head.pix_width, head.pix_height, 0, 0, 1);
****/

  GdkRectangle update_rect;
/*fprintf(stderr,"copyplane pixmap %d x %d\n",head.pix_width,head.pix_height); */
  if (invflag)
    gdk_draw_pixmap (widget->window,
		     widget->style->black_gc,
		     picture,
		     0, 0,
		     0, 0,
		     head.pix_width, head.pix_height);
  else
    gdk_draw_pixmap (widget->window,
		     widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		     picture,
		     0, 0,
		     0, 0,
		     head.pix_width, head.pix_height);
  update_rect.x = 0;
  update_rect.y = 0;
  update_rect.width = head.pix_width;
  update_rect.height = head.pix_height;
/*gtk_widget_draw((GtkWidget*)widget,&update_rect); */

}

void 
Display_Mol (GtkWidget * widget, GdkPixmap * picture)
/* calls the individual bond and text drawing functions to display the
   picture */
{
  struct data *hpc;
  struct dc *hpc_c;
  int d;
  char *c;
  struct xy_co *coord;
  GdkRectangle update_rect;

/*fprintf(stderr,"displaymol background %d x %d\n",head.pix_width,head.pix_height); */
  if (head.pix_width == 0 || head.pix_height == 0)
    return;
    gdk_draw_rectangle (picture,
			widget->style->white_gc,
			TRUE, 0, 0,
			head.pix_width,
			head.pix_height);

  hpc = da_root.next;
  if (!hpc)
    fprintf (stderr, "Help - somebody ate my atoms!!!\n");
  for (d = 0; d < hp.n; d++)
    {
      if (!hpc->bond)
	Drawline (widget, picture, hpc->x, hpc->y, hpc->tx, hpc->ty, hpc->smarked + hpc->tmarked);	/*single */
      if (hpc->bond == 5)
	DrawWedge (widget, picture, hpc->x, hpc->y, hpc->tx, hpc->ty, hpc->smarked + hpc->tmarked);
      if (hpc->bond == 6)
	DrawDashedWedge (widget, picture, hpc->x, hpc->y, hpc->tx, hpc->ty, hpc->smarked + hpc->tmarked);
      if (hpc->bond == 7)
	DrawWiggly (widget, picture, hpc->x, hpc->y, hpc->tx, hpc->ty, hpc->smarked + hpc->tmarked);
      if (hpc->bond == 8)
	DrawArrow (widget, picture, hpc->x, hpc->y, hpc->tx, hpc->ty, 1, hpc->smarked + hpc->tmarked);
      if (hpc->bond == 9)
	DrawArrow (widget, picture, hpc->x, hpc->y, hpc->tx, hpc->ty, 2, hpc->smarked + hpc->tmarked);
      if (hpc->bond == 10)
	DrawWide (widget, picture, hpc->x, hpc->y, hpc->tx, hpc->ty, hpc->smarked + hpc->tmarked);
      if (hpc->bond == 11)
	DrawCircle (widget, picture, hpc->x, hpc->y, hpc->tx, hpc->ty, hpc->smarked + hpc->tmarked);
      if (hpc->bond == 12)
	DrawDotted (widget, picture, hpc->x, hpc->y, hpc->tx, hpc->ty, hpc->smarked + hpc->tmarked);
      if (hpc->bond == 13)
        DrawAcross (widget, picture, hpc->x, hpc->y, hpc->tx, hpc->ty, hpc->smarked + hpc->tmarked);
      if (hpc->bond == 4)
	{			/*middouble */
	  coord = center_double_bond (hpc->x, hpc->y, hpc->tx, hpc->ty, 4);
	  Drawline (widget, picture, coord->x, coord->y, coord->tx, coord->ty, hpc->smarked + hpc->tmarked);
	  coord++;
	  Drawline (widget, picture, coord->x, coord->y, coord->tx, coord->ty, hpc->smarked + hpc->tmarked);
	}
      if (hpc->bond == 1 || hpc->bond == 3)
	{			/*leftdouble, triple */
	  coord = multi_bonds (hpc->x, hpc->y, hpc->tx, hpc->ty, 10);
	  Drawline (widget, picture, coord->x, coord->y, coord->tx, coord->ty, hpc->smarked + hpc->tmarked);
	  Drawline (widget, picture, hpc->x, hpc->y, hpc->tx, hpc->ty, hpc->smarked + hpc->tmarked);
	}
      if (hpc->bond == 2 || hpc->bond == 3)
	{			/*rightdouble, triple */
	  coord = multi_bonds (hpc->tx, hpc->ty, hpc->x, hpc->y, 10);
	  Drawline (widget, picture, coord->x, coord->y, coord->tx, coord->ty, hpc->smarked + hpc->tmarked);
	  Drawline (widget, picture, hpc->x, hpc->y, hpc->tx, hpc->ty, hpc->smarked + hpc->tmarked);
	}
      hpc = hpc->next;
      if (!hpc)
	{
	  fprintf (stderr, "Help - somebody ate my atoms!!!\n");
	  hp.n = d;
	  continue;
	}
    }

  hpc_c = dac_root.next;
  for (d = 0; d < hp.nc; d++)
    {
      c = hpc_c->c;
      Drawstring (widget, picture, hpc_c->x, hpc_c->y, c, hpc_c->direct, hpc_c->marked);
      hpc_c = hpc_c->next;
    }

  if (invflag)
    gdk_draw_pixmap (widget->window,
		     widget->style->black_gc,
		     picture,
		     0, 0,
		     0, 0,
		     head.pix_width, head.pix_height);
  else
    gdk_draw_pixmap (widget->window,
		     widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		     picture,
		     0, 0,
		     0, 0,
		     head.pix_width, head.pix_height);
  update_rect.x = 0;
  update_rect.y = 0;
  update_rect.width = head.pix_width;
  update_rect.height = head.pix_height;
  gtk_widget_draw ((GtkWidget *) widget, &update_rect);
  /*  CopyPlane(widget,picture); */

}


void 
Drawline (GtkWidget * widget, GdkPixmap * picture, int x, int y, int tx, int ty, int active)
/* draws a single bond */
{
      if (!active || invflag)
	gdk_draw_line (picture, widget->style->black_gc, (gint) (x * size_factor), (gint) (y * size_factor),
		       (gint) (tx * size_factor), (gint) (ty * size_factor));
      else
	gdk_draw_line (picture, widget->style->bg_gc[GTK_STATE_SELECTED], (gint) (x * size_factor), (gint) (y * size_factor),
		       (gint) (tx * size_factor), (gint) (ty * size_factor));
}

void 
DrawAcross (GtkWidget * widget, GdkPixmap * picture, int x, int y, int tx, int ty, int active)
/* draws a single bond on a white background */
{
  gint npoints = 4;
  GdkPoint mypoints[4];
  struct xy_co *coord;
  GdkGC *mygc;

  mygc = widget->style->white_gc;

  coord = center_double_bond (x, y, tx, ty, 6);
  mypoints[0].x = (coord->x+(coord->tx-coord->x)/4 ) * size_factor;
  mypoints[0].y = (coord->y+(coord->ty-coord->y)/4 ) * size_factor;
  mypoints[1].x = (coord->tx-(coord->tx-coord->x)/4 ) * size_factor;
  mypoints[1].y = (coord->ty-(coord->ty-coord->y)/4 ) * size_factor;
  coord++;
  mypoints[2].x = (coord->tx-(coord->tx-coord->x)/4 ) * size_factor;
  mypoints[2].y = (coord->ty-(coord->ty-coord->y)/4 ) * size_factor;
  mypoints[3].x = (coord->x+(coord->tx-coord->x)/4 ) * size_factor;
  mypoints[3].y = (coord->y+(coord->ty-coord->y)/4 ) * size_factor;
  gdk_draw_polygon (picture, mygc, TRUE, (GdkPoint *) mypoints, (gint) npoints);
      if (!active || invflag)
	gdk_draw_line (picture, widget->style->black_gc, (gint) (x * size_factor), (gint) (y * size_factor),
		       (gint) (tx * size_factor), (gint) (ty * size_factor));
      else
	gdk_draw_line (picture, widget->style->bg_gc[GTK_STATE_SELECTED], (gint) (x * size_factor), (gint) (y * size_factor),
		       (gint) (tx * size_factor), (gint) (ty * size_factor));
}

void 
DrawDotted (GtkWidget * widget, GdkPixmap * picture, int x, int y, int tx, int ty, int active)
/* draws a dotted bond */
{
GdkPoint mypoints[10];
int xlen,ylen,i;
gint npoints=10;

	xlen = tx-x;
	ylen = ty-y;

	for(i=0;i<npoints;i++){
	mypoints[i].x=(x+i*0.1*xlen)*size_factor;
	mypoints[i].y=(y+i*0.1*ylen)*size_factor;  
  	}
      if (!active || invflag)
    gdk_draw_points (picture, widget->style->black_gc, (GdkPoint*) mypoints,(gint) npoints);
      else
    gdk_draw_points (picture, widget->style->bg_gc[GTK_STATE_SELECTED], (GdkPoint*) mypoints,(gint) npoints);
}

void 
DrawWide (GtkWidget * widget, GdkPixmap * picture, int x, int y, int tx, int ty, int active)
/* draws a wide single bond */
{
  gint npoints = 4;
  GdkPoint mypoints[4];
  struct xy_co *coord;
  GdkGC *mygc;

  mygc = widget->style->black_gc;
  if (active  && !invflag)
    mygc = widget->style->bg_gc[GTK_STATE_SELECTED];

  coord = center_double_bond (x, y, tx, ty, 6);
  mypoints[0].x = coord->x * size_factor;
  mypoints[0].y = coord->y * size_factor;
  mypoints[1].x = coord->tx * size_factor;
  mypoints[1].y = coord->ty * size_factor;
  coord++;
  mypoints[2].x = coord->tx * size_factor;
  mypoints[2].y = coord->ty * size_factor;
  mypoints[3].x = coord->x * size_factor;
  mypoints[3].y = coord->y * size_factor;
  gdk_draw_polygon (picture, mygc, TRUE, (GdkPoint *) mypoints, (gint) npoints);

}


void 
DrawCircle (GtkWidget * widget, GdkPixmap * picture, int x, int y, int tx, int ty, int active)
/* draws a circle of radius (tx/ty)-(x/y) around (x/y) */
{
  GdkGC *mygc;
  int topleftx,toplefty;
  int radius;
  

  mygc = widget->style->black_gc;
  if (active && !invflag)
    mygc = widget->style->bg_gc[GTK_STATE_SELECTED];

  radius = calc_vector (abs (tx - x), abs (ty - y)) * size_factor;
  
  topleftx = x * size_factor - radius;
  toplefty = y * size_factor - radius;
  gdk_draw_arc (picture, mygc, FALSE, topleftx, toplefty, 2*radius, 2*radius, 0, 360*64);

}


void 
DrawWiggly (GtkWidget * w, GdkPixmap * picture, int x, int y, int tx, int ty, int active)
/* draws a wavy line */
{
  gint ax, ay, width, height, angle1, angle2;
  int narcs, veclen, boxlen;
  int i, xlen, ylen, ang;
  int boxcorx, boxcory;

  GdkGC *mygc;

  mygc = w->style->black_gc;
  if (active && !invflag)
    mygc = w->style->bg_gc[GTK_STATE_SELECTED];


  narcs = 5;

  xlen = tx - x;
  ylen = ty - y;

  veclen = calc_vector (abs (tx - x), abs (ty - y));
  ang = 180. + asin (copysign ((float) ylen / (float) veclen, xlen * -ylen)) * 180. / 3.14159;

  boxlen = 0.2 * veclen;
  boxcorx = (1. - (float) xlen / (float) veclen) * boxlen / 2;
  boxcory = (1. - (float) ylen / (float) veclen) * boxlen / 2;

  for (i = 0; i < narcs; ++i)
    {
      ax = (x + 0.2 * i * xlen - boxcorx) * size_factor;
      ay = (y + 0.2 * i * ylen - boxcory) * size_factor;
      width = boxlen * size_factor;
      height = boxlen * size_factor;
      angle1 = ang * 64;
      angle2 = -180 * 64 * pow (-1, i);

      gdk_draw_arc (picture, mygc, FALSE, ax, ay, width, height, angle1, angle2);
    }

}

void 
DrawArrow (GtkWidget * w, GdkPixmap * picture, int x, int y, int tx, int ty, int head, int active)
/* draws an arrow with either full or one-sided arrowhead */
{
  int xlen, ylen, xbase, ybase;
  gint npoints;
  float veclen, headfact;
  GdkPoint mypoints[3];
  GdkGC *mygc;

  mygc = w->style->black_gc;
  if (active  && !invflag)
    mygc = w->style->bg_gc[GTK_STATE_SELECTED];

  xlen = tx - x;
  ylen = ty - y;
  veclen = sqrt (xlen * xlen + ylen * ylen);
/*  headfact = 1. - 20. / veclen;*/
  headfact=0.8;
  xbase = x + headfact * xlen;
  ybase = y + headfact * ylen;


  mypoints[0].x = tx * size_factor;
  mypoints[0].y = ty * size_factor;

  mypoints[1].x = (xbase + 0.1 * ylen) * size_factor;
  mypoints[1].y = (ybase - 0.1 * xlen) * size_factor;
  /*
  mypoints[1].x = (xbase + 0.07 * ylen) * size_factor;
  mypoints[1].y = (ybase - 0.07 * xlen) * size_factor;
*/
  if (head == 1)
    {
      mypoints[2].x = xbase * size_factor;	/*on baseline */
      mypoints[2].y = ybase * size_factor;
    }
  else
    {

      mypoints[2].x = (xbase - 0.1 * ylen) * size_factor;
      mypoints[2].y = (ybase + 0.1 * xlen) * size_factor;
/*
      mypoints[2].x = (xbase - 0.07 * ylen) * size_factor;
      mypoints[2].y = (ybase + 0.07 * xlen) * size_factor;
*/
    }

  npoints = 3;
  gdk_draw_line (picture, mygc, x * size_factor, y * size_factor, tx * size_factor, ty * size_factor);
  gdk_draw_polygon (picture, mygc, TRUE, (GdkPoint *) mypoints, (gint) npoints);
}

void 
DrawDashedWedge (GtkWidget * w, GdkPixmap * picture, int x, int y, int tx, int ty, int active)
/* draws the dashed wedge for a bond behind the image plane */
{
  int i, xlen, ylen;
  GdkGC *mygc;

  mygc = w->style->black_gc;
  if (active && !invflag)
    mygc = w->style->bg_gc[GTK_STATE_SELECTED];

  xlen = tx - x;
  ylen = ty - y;


  for (i = 0; i < 11; i++)
    gdk_draw_line (picture, mygc,
		   (x + 0.1 * i * xlen - 0.01 * ylen * i) * size_factor, (y + 0.1 * i * ylen + 0.01 * xlen * i) * size_factor,
		   (x + 0.1 * i * xlen + 0.01 * ylen * i) * size_factor, (y + 0.1 * i * ylen - 0.01 * xlen * i) * size_factor);
}

void 
DrawWedge (GtkWidget * w, GdkPixmap * picture, int x, int y, int tx, int ty, int active)
/* draws the wedge-shaped single bond 'pointing towards the viewer' */
{
  int xlen, ylen;
  gint npoints;
  GdkPoint mypoints[3];
  GdkGC *mygc;

  mygc = w->style->black_gc;
  if (active && !invflag)
    mygc = w->style->bg_gc[GTK_STATE_SELECTED];

  xlen = tx - x;
  ylen = ty - y;

  mypoints[0].x = x * size_factor;
  mypoints[0].y = y * size_factor;
  mypoints[1].x = (tx - 0.1 * ylen) * size_factor;
  mypoints[1].y = (ty + 0.1 * xlen) * size_factor;
  mypoints[2].x = (tx + 0.1 * ylen) * size_factor;
  mypoints[2].y = (ty - 0.1 * xlen) * size_factor;
  npoints = 3;
  gdk_draw_polygon (picture, mygc, TRUE, (GdkPoint *) mypoints, (gint) npoints);
}


void 
Drawstring (GtkWidget * w, GdkPixmap * picture, int x, int y, char *c, int direct, int active)
/* draws a label with sub- and superscripting, symbols and text justification */
{
  int ha, htw, tw, a;
  int nch, textl, chl;
  char *l, *hc, hl[2];
  int d, hx, n;
  int nsub=0;
  int nsup=0;
  int variance[MAXCL];
  char text[MAXCL];
  char symbol[MAXCL];
  char slanted[MAXCL];
  GdkGC *mygc;

  mygc = w->style->black_gc;
  if (active && !invflag) 
    mygc = w->style->bg_gc[GTK_STATE_SELECTED];

  x = x * size_factor;
  hx = x;
  y = y * size_factor;

  a = gdk_char_height (font, 'X');
  ha = gdk_char_height (font, 'x') / 2;
  n = strlen (c);

  hc = c;
  for (d = 0; d < n; d++)
    {
      symbol[d] = FALSE;
      slanted[d] = FALSE;
      if ((variance[d] = Extra_char (*hc)) != 0)
	{
	  hc++;
	  --n;
	}
      text[d] = *hc++;
      if (text[d] == '@')
	{
	  symbol[d] = TRUE;
	  text[d] = *hc++;
	  --n;
	}

    if (text[d] == '|')
      { 
        slanted[d] = TRUE;
    	text[d] = *hc++; 
    	--n;
    	} 

      if (text[d] == '\\')
	text[d] = ' ';
    }

  nch = n;
  if (nch > 1)
    {
      if (variance[nch - 1])
	--nch;
      textl = gdk_text_width (font, c, nch);
      chl = (textl / nch) / 2;
      hx = x + (textl / 2 - chl) * direct;
    }
  nch = n;

  x = hx;
  for (d = 0; d < n; d++)
    {
      hl[0] = text[d];
      hl[1] = 0;
      l = &hl[0];
      tw = gdk_text_width (font, l, strlen (l));
      if (symbol[d])
	tw = gdk_text_width (symbfont, l, strlen (l));
      htw = tw / 2;
/* erase a circular area slightly larger than the current character to
   create some space around the label */
	gdk_draw_arc (picture, w->style->white_gc, 1,
		      x - htw - 7 * size_factor,
		      y - a + ha - 5 * size_factor + variance[d],
		      htw * 2 + 12 * size_factor,
		      a + 12 * size_factor,
		      0, 360 * 64);
      x = x + tw;
    }

  n = nch;
  x = hx;
  for (d = 0; d < n; d++)
    {
      hl[0] = text[d];
      hl[1] = 0;
      l = &hl[0];
      tw = gdk_text_width (font, l, strlen (l));
      tw = gdk_char_width (font, 'O');
      htw = gdk_text_width (font, l, strlen (l))/2;
      if (symbol[d]){ 
	tw = gdk_text_width (symbfont, l, strlen (l));
      htw = tw / 2;
	}
      if (variance[d])
	{
	  tw = gdk_text_width (smallfont, l, strlen (l));
      tw = gdk_char_width (smallfont, 'N');
	  if (symbol[d])
	    tw = gdk_text_width (ssymbfont, l, strlen (l));
	  htw = tw / 2;
          if (variance[d]<0){ 
          nsub++;
          htw=htw+nsup*tw;
          }else{
          nsup++;
          htw=htw+nsub*tw;
	  }
	}else{
	nsup=0;
	nsub=0;
	}
      if (variance[d])
	{
	  if (symbol[d])
	    {
	      gdk_draw_text (picture, ssymbfont, w->style->white_gc, x - htw, y + ha + variance[d],
			     l, strlen (l));
	      gdk_draw_text (picture, ssymbfont, mygc, x - htw, y + ha + variance[d],
			     l, strlen (l));
	    }
	  else
	    {
	      gdk_draw_text (picture, smallfont, w->style->white_gc, x - htw, y + ha + variance[d],
			     l, strlen (l));
	      gdk_draw_text (picture, smallfont, mygc, x - htw, y + ha + variance[d],
			     l, strlen (l));
	    }
	}
      else
	{
	  if (symbol[d])
	    {
	      gdk_draw_text (picture, symbfont, w->style->white_gc, x - htw, y + ha,
			     l, strlen (l));
	      gdk_draw_text (picture, symbfont, mygc, x - htw, y + ha,
			     l, strlen (l));
	    }
	  else
	  if (slanted[d])
	    {
	      gdk_draw_text (picture, slfont, w->style->white_gc, x - htw, y + ha,
			     l, strlen (l));
	      gdk_draw_text (picture, slfont, mygc, x - htw, y + ha,
			     l, strlen (l));
	    }else
	    {
	      gdk_draw_text (picture, font, w->style->white_gc, x - htw, y + ha,
			     l, strlen (l));
	      gdk_draw_text (picture, font, mygc, x - htw, y + ha,
			     l, strlen (l));
	    }
	}
      x = x + tw;
    }
}

int 
Extra_char (char c)
/* process control characters for sub- and superscripting */
{
  int ha = gdk_char_height (font, 'x') / 2;
  if (c == '_')
    return (ha);
  if (c == '^')
    return (-ha);
  return (0);
}

int 
Load_Font (int fnt)
/* load the normal, subscript and symbol fonts for all zoom scales */
{
/* NB: entries 0 and 1 are currently unused, the default font is 4(!) */
  gchar *symtype[] =
  {"*-symbol-*-*-8-*", "*-symbol-*-*-10-*",
   "*-symbol-*-*-12-*", "*-symbol-*-*-14-*", "*-symbol-*-*-18-*",
   "*-symbol-*-*-18-*", "*-symbol-*-*-24-*"};

  gchar *ssymtype[] =
  {"*-symbol-*-*-8-*", "*-symbol-*-*-8-*",
   "*-symbol-*-*-10-*", "*-symbol-*-*-12-*", "*-symbol-*-*-14-*",
   "*-symbol-*-*-18-*", "*-symbol-*-*-24-*"};

  gchar *fntype[] =
  {"*-helvetica-medium-r-normal--8-*", "*-helvetica-medium-r-normal--10-*",
   "*-helvetica-medium-r-normal--12-*", "*-helvetica-medium-r-normal--14-*", 
   "*-helvetica-medium-r-normal--18-*",
   "*-helvetica-medium-r-normal--18-*", "*-helvetica-medium-r-normal--24-*"};
/*  {"5x7", "6x10", "7x13", "9x15", "8x16",
   "10x20", "12x24"};*/

  gchar *sfntype[] =
  {"*-helvetica-medium-r-normal--8-*", "*-helvetica-medium-r-normal--8-*",
   "*-helvetica-medium-r-normal--10-*", "*-helvetica-medium-r-normal--12-*", 
   "*-helvetica-bold-r-normal--14-*",
   "*-helvetica-bold-r-normal--14-*", "*-helvetica-medium-r-normal--24-*"};
/*  {"5x7", "5x7", "6x10", "8x13", "7x14",
   "8x13bold", "10x20"};*/

  gchar *sltype[] =
  {"*-helvetica-medium-o-normal--8-*", "*-helvetica-medium-o-normal--10-*",
   "*-helvetica-medium-o-normal--12-*", "*-helvetica-medium-o-normal--14-*", 
   "*-helvetica-medium-o-normal--18-*",
   "*-helvetica-medium-o-normal--18-*", "*-helvetica-medium-o-normal--24-*"};

  if (fnt > 6)
    return (0);

  if ((font = gdk_font_load (fntype[fnt])) == NULL)
    {
      fprintf (stderr, "failed to load font %s !!!\n", fntype[fnt]);
      return (0);
    }
  if ((symbfont = gdk_font_load (symtype[fnt])) == NULL){
  fprintf(stderr,"Failed to load symbol font, using standard font\n");
    symbfont = font;
    }
  if ((ssymbfont = gdk_font_load (ssymtype[fnt])) == NULL)
    ssymbfont = font;
  if ((smallfont = gdk_font_load (sfntype[fnt])) == NULL)
    smallfont = font;
  if ((slfont = gdk_font_load (sltype[fnt])) == NULL)
    slfont = font;
  return (1);
}

void 
Set_Line (GtkWidget * w, int lsty)
/* define standard line attributes for bond drawing */
{
  gdk_gc_set_line_attributes (w->style->white_gc, lsty, 0, GDK_CAP_BUTT, GDK_JOIN_MITER);
  gdk_gc_set_line_attributes (w->style->black_gc, lsty, 0, GDK_CAP_BUTT, GDK_JOIN_MITER);
}
